'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var Vue = _interopDefault(require('vue'));

var originalContent = undefined;

function highlight(content, word) {
  var spanStart = "<span style='padding:0px 5px; background-color:#009688; color:white'>";
  var spanEnd = "</span>";
  var result = content;
  if (word != '') {
    var pattern = "\\b(" + word + ")\\b";
    var regex = new RegExp(pattern, "g");
    result = content.replace(regex, spanStart + "$&" + spanEnd);
  }
  return result;
}

var vueHighlighter = {
  bind: function bind(el, binding, vnode) {
    originalContent = el.innerHTML;
    if (binding.arg == "word") {
      el.innerHTML = highlight(originalContent, binding.value);
    }
  },
  update: function update(el, binding, vnode, oldVnode) {
    el.innerHTML = highlight(el.textContent, binding.value);
  },
  unbind: function unbind(el, binding, vnode) {
    el.innerHTML = originalContent;
  }
};

Vue.directive("highlight", vueHighlighter);

module.exports = vueHighlighter;
